package com.miaxis.newgzpt.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;

/**
 * <p>
 * 学员基本信息表
 * </p>
 *
 * @author ${author}
 * @since 2021-03-09
 */

@Data
@EqualsAndHashCode(callSuper = false)
public class TrainFinishDTO implements Serializable {

    @ApiModelProperty(value = "学员studentId")
    private long studentId;

    @ApiModelProperty(value = "科目")
    private String trainSubject;

    @ApiModelProperty(value = "地区编号")
    private String dqbh;

}
