package com.miaxis.param.domain;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.miaxis.common.annotation.Excel;
import com.miaxis.common.core.domain.BaseBusinessEntity;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
/**
 * 前端控制参数对象 app_param
 *
 * @author miaxis
 * @date 2021-12-30
 */
@Data
@TableName("app_param")
@ApiModel(value = "AppParam", description = "前端控制参数对象 app_param")
public class AppParam extends BaseBusinessEntity{

    private static final long serialVersionUID = 1L;

    /** $column.columnComment */
    @TableId(value = "id")
    @ApiModelProperty(value = "$column.columnComment")
    private Long id;

    /** 健 */
    @Excel(name = "健")
    @TableField("key")
    @ApiModelProperty(value = "健")
    private String key;

    /** 值 */
    @Excel(name = "值")
    @TableField("value")
    @ApiModelProperty(value = "值")
    private String value;

    /** 备注 */
    @Excel(name = "备注")
    @TableField("remark")
    @ApiModelProperty(value = "备注")
    private String remark;
}
