package com.miaxis.param.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.miaxis.param.domain.AppParam;

/**
 * 前站控制参数Mapper接口
 *
 * @author miaxis
 * @date 2021-12-30
 */
public interface AppParamMapper extends BaseMapper<AppParam> {
    /**
     * 查询前站控制参数列表
     *
     * @param appParam 前站控制参数
     * @return 前站控制参数集合
     */
    public List<AppParam> selectAppParamList(AppParam appParam);

}
