package com.miaxis.param.service;

import java.util.List;
import com.miaxis.param.domain.AppParam;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 前站控制参数Service接口
 *
 * @author miaxis
 * @date 2021-12-30
 */
public interface IAppParamService extends IService<AppParam>{
    /**
     * 查询前站控制参数列表
     *
     * @param appParam 前站控制参数
     * @return 前站控制参数集合
     */
    public List<AppParam> selectAppParamList(AppParam appParam);
}
