package com.miaxis.dict.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.miaxis.dict.domain.DictCity;

/**
 * 全国城市Mapper接口
 *
 * @author miaxis
 * @date 2021-03-18
 */
public interface DictCityMapper extends BaseMapper<DictCity> {
    /**
     * 查询全国城市列表
     *
     * @param dictCity 全国城市
     * @return 全国城市集合
     */
    public List<DictCity> selectDictCityList(DictCity dictCity);

}
