package com.miaxis.feign.service;


import com.miaxis.common.config.FeignConfig;
import com.miaxis.feign.dto.fulu.FuluDTO;
import com.miaxis.feign.dto.fulu.FuluResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;

/**
 *
 * 福禄开放接口
 */
@FeignClient(name="fuluService",
        url = "${fulu.url}",configuration = FeignConfig.class)
@Component
public interface IFuluService {
    /**
     *  通用接口
     * @return
     */
    @GetMapping(value = "/api/getway",consumes = MediaType.APPLICATION_JSON_VALUE)
    FuluResult fuluCommonApi(FuluDTO fuluDTO);
}
