package com.miaxis.feign.service.fallback;

import com.miaxis.feign.service.ICarService;
import org.springframework.stereotype.Component;

/**
 *  调用服务端接口（异常、超时、宕机） 降级处理
 * @author wwl
 * @version 1.0
 * @date 2021/5/21 10:20
 */
@Component
public class CarFallBackService implements ICarService {

    @Override
    public String car(String type, String from, String pagesize) {
        return "接口请求异常";
    }
}
