package com.miaxis.jsgzh.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.miaxis.jsgzh.domain.JsgzhUser;

/**
 * 极速公众号用户Mapper接口
 *
 * @author miaxis
 * @date 2021-06-08
 */
public interface JsgzhUserMapper extends BaseMapper<JsgzhUser> {
    /**
     * 查询极速公众号用户列表
     *
     * @param jsgzhUser 极速公众号用户
     * @return 极速公众号用户集合
     */
    public List<JsgzhUser> selectJsgzhUserList(JsgzhUser jsgzhUser);



    /**
     * 查询极速公众号用户列表
     *
     * @param jsgzhUser 极速公众号用户
     * @return 极速公众号用户集合
     */
    public List<JsgzhUser> selectJsgzhUserListNullName(JsgzhUser jsgzhUser);
    /**
     * 根据openid更新对象
     * @param jsgzhUser
     * @return
     */
    public  int updateJsgzhUserByOpenId(JsgzhUser jsgzhUser);
}
