package com.miaxis.jsgzh.service;

import java.util.List;
import com.miaxis.jsgzh.domain.JsgzhUser;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 极速公众号用户Service接口
 *
 * @author miaxis
 * @date 2021-06-08
 */
public interface IJsgzhUserService extends IService<JsgzhUser>{
    /**
     * 查询极速公众号用户列表
     *
     * @param jsgzhUser 极速公众号用户
     * @return 极速公众号用户集合
     */
    public List<JsgzhUser> selectJsgzhUserList(JsgzhUser jsgzhUser);
}
