package com.miaxis.newgzpt.domain;

import java.math.BigDecimal;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import java.io.Serializable;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 *
 * </p>
 *
 * @author ${author}
 * @since 2021-03-23
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("GZPT_TRAIN_RECORD")
@ApiModel(value="GzptTrainRecord对象", description="")
public class GzptTrainRecord implements Serializable {

    private static final long serialVersionUID = 1L;

    @TableId("ID")
    @ApiModelProperty(hidden = true)
    private Long id;

    @ApiModelProperty(value = "学员ID",hidden = true)
    @TableField("STUDENT_ID")
    private Long studentId;

    @ApiModelProperty(value = "训练开始时间")
    @TableField("BEGIN_TIME")
    private String beginTime;

    @ApiModelProperty(value = "训练结束时间")
    @TableField("END_TIME")
    private String endTime;

    @ApiModelProperty(value = "训练类型 android,ios,网上训练")
    @TableField("TRAIN_TYPE")
    private String trainType;

    @ApiModelProperty(value = "训练总时间")
    @TableField("TRAIN_TIME")
    private String trainTime;

    @ApiModelProperty(value = "0 未处理 1 传送成功 2 训练中将无法同步  4学时验证不合格  5部分传输成功 6 异常数据")
    @TableField("IS_SUBMIT")
    private String isSubmit;

    @ApiModelProperty(value = "1:科目一理论 4:科目四理论")
    @TableField("PXKM")
    private Integer pxkm;

    @ApiModelProperty(value = "数据来源 1 远程 2 课堂 2018-03-19 新增")
    @TableField("SOURCE")
    private Integer source;

    @ApiModelProperty(value = "未成功或部分未成功原因")
    @TableField("REASON")
    private String reason;

    @ApiModelProperty(value = "课堂ID")
    @TableField("CLASSID")
    private String classid;


}
