package com.miaxis.newgzpt.vo;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 视频VIP表
 * </p>
 *
 * @author ${author}
 * @since 2022-01-27
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class GzptVideoVipVO implements Serializable {

    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "ID")
    private Long id;

    @ApiModelProperty(value = "用户ID")
    private Long userId;

    @ApiModelProperty(value = "用户名")
    private String userName;


    @ApiModelProperty(value = "科目2  到期时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date subject2;

    @ApiModelProperty(value = "科目3  到期时间")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date subject3;

    @ApiModelProperty(value = "签名")
    private String sign;


}
