package com.miaxis.order.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.miaxis.order.domain.OrderInfo;

/**
 * 订单信息Mapper接口
 *
 * @author miaxis
 * @date 2022-06-01
 */
public interface OrderInfoMapper extends BaseMapper<OrderInfo> {
    /**
     * 查询订单信息列表
     *
     * @param orderInfo 订单信息
     * @return 订单信息集合
     */
    public List<OrderInfo> selectOrderInfoList(OrderInfo orderInfo);

}
