package com.miaxis.order.service;

import java.util.List;
import com.miaxis.order.domain.OrderInfo;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 订单信息Service接口
 *
 * @author miaxis
 * @date 2022-06-01
 */
public interface IOrderInfoService extends IService<OrderInfo>{
    /**
     * 查询订单信息列表
     *
     * @param orderInfo 订单信息
     * @return 订单信息集合
     */
    public List<OrderInfo> selectOrderInfoList(OrderInfo orderInfo);
}
